/* Test for Coco. Copyright (C) 1994 Yasumsa uyama.	Parser module */
#include "stdafx.h"

#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ctype.h>
#include <errno.h>
#include <stdio.h>


#define PARSERSTACKSIZE 25
#define MAXINPUT 256


//CONST
#define cmaxname   180
#define cmaxnamep   18
#define cmaxcode    62
#define cmaxany      1
#define cmaxeps      1
#define cmaxt       10
#define cmaxp       10
#define cmaxs       18
#define cstartpc	  58

//CONST  /*G-code instructions*/
#define t 0
#define ta 1
#define nt 2
#define nta 3
#define nts 4
#define ntas 5
#define any 6
#define anya 7
#define eps 8
#define epsa 9
#define jmp 10
#define ret 11
#define errdistmin 2
#define lmaxs 50
#define eofsy 0

////////////////////////////////////
// types:    from TREMINAMS
#define contentsy 1
#define inlinesy 2
#define filenamesy 3
#define charsetsy 4
#define languagesy 5
#define isostrsy 6
#define eqlsy 7
#define colonsy    8
#define semicolonsy 9
#define noncocosy 10
/////////////////////////////////////

#define MAXFILENAMELEN 256


int errors =0;

unsigned short int typ;
int ch;
char b[256];
int bl=0;
int line = 1, col=0;
int correct;

extern CString isobuf;


//void Semant(unsigned int sem, int *att);

struct Pragma{
  unsigned short int sem2;
  unsigned short int sem3;
  };
Pragma Pragmalist[cmaxp-cmaxt+1];
struct SymbolnodeSYN{
  unsigned short int startpc;
  BOOL del;
  unsigned short int first[1+cmaxt/16];
  };
struct TAB{
  unsigned short int header[8];
  unsigned char code[(cmaxcode/2+2)*2];
  SymbolnodeSYN ntsymbols[cmaxs-cmaxp];
  unsigned short int epsset[cmaxeps][cmaxt/16+1];
  unsigned short int anyset[cmaxany][cmaxt/16+1];
  unsigned short int  nra[cmaxp+1];
  Pragma ps[cmaxp-cmaxt+1];
  unsigned short int namep[cmaxnamep+1];
  char name[(cmaxname/2+2)*2];
  };
TAB *tab;
extern BOOL correct;
unsigned short int pc;
unsigned short int errdist;
unsigned short int newlacts[cmaxt+1];
unsigned short int newpc[cmaxt+1];
unsigned short int s[lmaxs+1];
unsigned short int olds[lmaxs+1];
unsigned short int lacts;
void GetSymInstr(unsigned short int pc,unsigned short int &opcode,unsigned short int &sy,
	 unsigned short int &nextpc,unsigned short int &altpc);
void RestoreStack(void);
void SaveStack(void);
unsigned short int StackElem(unsigned short int i);
void Triple(unsigned short int altroot);





/*TableContents   A dirty trick to initialize the grammar tables
------------------------------------------------------------------*/
unsigned short int TABLE[]={
//  INLINE(
     62u,   10u,   10u,   18u,    1u,    0u,   18u,  180u,
/*---G-code---*/
    524u, 2818u, 3340u,  265u,   17u,  526u, 3338u,    7u, 2049u, 2818u,
   3840u, 1794u, 4107u,  529u,    7u,  530u, 2816u,  256u, 2048u,  512u,
   2304u,  779u,    4u,    5u,    6u, 2816u,  779u,    6u, 2818u, 2816u,
     11u,
/*---nt-symbols---*/
      1u,    0u,    2u,    4u,    0u,    2u,   20u,    0u,    2u,   27u,
      0u,    8u,   34u,    0u,    2u,   45u,    0u,   16u,   52u,    0u,
      8u,   55u,    0u,   64u,
/*---eps followers---*/
      1u,
/*---any sets---*/
      0u,
/*---attribute numbers---*/
      0u,    0u,    0u,    0u,    0u,    0u,    0u,    0u,    0u,    0u,
      0u,
/*---pragma semantic---*/
      0u,    0u,
/*---name pointers---*/
      1u,    5u,   10u,   17u,   23u,   29u,   34u,   41u,   45u,   49u,
     53u,   62u,   67u,   79u,   91u,  101u,  121u,  142u,  161u,
/*---name list---*/
  17743u,17920u,17231u,20052u,   73u,20044u,18766u,17664u,17998u,16717u,
  17664u,17224u,21317u,21504u,19521u,20039u,   73u,21327u,17473u,21504u,
  10045u, 9984u,10042u, 9984u,10043u, 9984u,28271u,25455u,25455u,29561u,
    101u,30836u,28672u,25455u,29298u,25955u,29797u,30836u,28672u,26990u,
  26996u,26977u,27758u,24941u,25856u,28532u,26725u,29294u,24941u,25856u,
  25976u,29797u,28260u,25956u,26990u,26996u,26977u,27758u,24941u,25856u,
  25976u,29797u,28260u,25956u,26990u,26996u,26977u,27766u,24940u,30053u,
    101u,30836u,25966u,25701u,25711u,29800u,25970u,28257u,28005u,29440u,
  25976u,29797u,28260u,25956u,28532u,26725u,29302u,24940u,30053u,29440u,0u};

//	END TableContents;



struct TOKENREC
{
	char state;
	char content[64];
	char inl[64];
    char chset[64];
	char lang[16];
	char filename[64];
	char isofname[256];//MAXFILENAMELEN + 1];
};

static struct TOKENREC stack[PARSERSTACKSIZE], curtoken , token1;
int stacktop, tokentype, error;
char *input;


int iscontent(char *s)
{
 int len = strlen(s);

 if (strncmp(s, input, len) == 0)
 {
	strncpy(curtoken.content, input, len);
	curtoken.content[len] = 0;
	input += len;
	return(TRUE);
 }
 return(FALSE);
} 

int isinline(char *s)
{
 int len = strlen(s);

 if (strncmp(s, input, len) == 0)
 {
	strncpy(curtoken.inl, input, len);
	curtoken.inl[len] = 0;
	input += len;
	return(TRUE);
 }
 return(FALSE);
} 

int isfilename(char *s)
{
 int len = strlen(s);
 if (strncmp(s, input, len) == 0)
 {
 	int len = 0;
	while(*input != '='){
		curtoken.filename[len] = *input;
		input++; len++;
	}
	curtoken.filename[len] = NULL;
	return(TRUE);
 }
 return(FALSE);
} 

int ischarset(char *s)
{
 int len = strlen(s);

 if (strncmp(s, input, len) == 0)
 {
	strncpy(curtoken.chset, input, len);
	curtoken.chset[len] = 0;
	input += len;
	return(TRUE);
 }
 return(FALSE);
} 

int islanguage()
{
	int len = 0;
	if(*input == '\''){
		curtoken.lang[len] = *input;
		input++; len++;
		while(*input != '\''){
			curtoken.lang[len] = *input;
			input++; len++;
		}
		curtoken.lang[len] = *input;
		input++; len++;
		curtoken.lang[len] = NULL;
		return(TRUE);
	}
	else return(FALSE);
} 

int isostr()
{
	int len = 0;
	if(*input == '%'){
		while((*input=='%') || isalpha(*input) || isdigit(*input)){
			curtoken.isofname[len] = *input;
			input++; len++;
		}
		curtoken.isofname[len] = NULL;
		return(TRUE);
	}
	else return(FALSE);
} 


void push(struct TOKENREC *token)
/* Vg[NX^bNɃvbV */
{
 if (stacktop == PARSERSTACKSIZE - 1)
 {
//	errormsg(MSGSTACKERROR);
	error = TRUE;
 }
 else
	stack[++stacktop] = *token;
} /* push */

struct TOKENREC pop(void)
/* X^bNgbṽg[N|bv */
{
 return(stack[stacktop--]);
} /* pop */




void stringupper(char *s)
{
	while (*s)
	{
		*s = (char)toupper(*s);
		s++;
	}
}

//header file for cclex.cpp

int nexttoken(void)
/* ̓Xg[玟̃g[Nǂݍ */
{
 while ((*input == ' ')||(*input == '\t'))
	input++;
 if (*input == 0){
	 typ=eofsy;return(typ);
 }
 if (isalpha(*input)){
	 if( iscontent("Content-Disposition") ){
	 	typ=contentsy; return(typ);
	 }else if(isinline("inline")){
		typ=inlinesy; return(typ);
	 }else if(isfilename("filename")){
		typ=filenamesy; return(typ);
	 }else if(ischarset("ISO-2022-JP")){
		typ=charsetsy; return(typ);
	 }else{
		typ=noncocosy; return(typ);
	 }
 }else switch(*input){
	case '\'': islanguage(); typ=languagesy; return(typ);
	case '%' : isostr(); typ=isostrsy ; return(typ);
	case '=' : typ=eqlsy; input++; return(typ);
	case ';' : typ=semicolonsy; input++; return(typ);
	case ':' : typ=colonsy; input++; return(typ);
	default  : typ=noncocosy; return(typ);
 } /* switch */
} /* nexttoken */

//IMPLEMENTATION MODULE esem;
//FROM elex IMPORT at;



void Semant(unsigned short int sem){

switch(sem){
    case 11: break;

    case  12: /*line 198*/
         push(&curtoken);
         break;
    case  13: /*line 204*/
         token1=pop();
         strcat(token1.isofname,curtoken.isofname);
         strcpy(curtoken.isofname,token1.isofname);
         push(&curtoken);
         break;
    default:
	break;
    }/* switch */
}



/*Match     Check if sy is mumber of the specified set
------------------------------------------------------*/
BOOL Match(unsigned short int sy,unsigned short int set[]){
  if(set[sy/16]&(0x0001<<(sy%16))){return TRUE; }
  else {return FALSE; }
  }/* Match() */

/*NextSym     Get next symbol
----------------------------------------*/
void NextSym(void){
  while(1){
    nexttoken();
/*    if(printinput){
      WriteString(fcon,"$(in:"); WriteCard(fcon,typ,3);
      WriteString(fcon,") ");
      }
    if(printnodes){
      WriteCard(fcon,lacts,3);WriteString(fcon,"| ");
      }*/
    if(typ<=cmaxt){
      return ;
      }
    if(correct && (tab->ps[typ-cmaxt].sem2!=0)){
      Semant(tab->ps[typ-cmaxt].sem2);
      }
    if(correct && (tab->ps[typ-cmaxt].sem3!=0)){
      Semant(tab->ps[typ-cmaxt].sem3);
      }
    if(typ==eofsy){
      return;
      }
    }
  }/* NextSym() */


/*================= SYNTAXSTACK ===================*/

/*Pop
---------------*/
void Pop(unsigned short int &loc){

  if(lacts>0){
	loc=s[lacts]; lacts--;
	}
  else{
errors += 1;
//	WriteString(fcon,"--- Parser stack underflow.$");
//	getch(); /* HALT */
	}
//  if(printnodes){
//	WriteString(fcon,"  pop");
//	}
  }/* Pop() */

/*Push
------------*/
void Push(unsigned short int loc){

  if(lacts<lmaxs){
	lacts++; s[lacts]=loc;
	}

  }/* Push() */

/*
 unsigned short int altroot;
  BOOL mustread;
  unsigned short int opcode;
  BOOL running;
  unsigned short int sy,tmp,tmp1;
  short int i;
*/

/*Parse      Proper syntax analyzer
-------------------------------------*/
void Parse(BOOL &corr){
  unsigned short int altroot;
  BOOL mustread;
  unsigned short int opcode;
  BOOL running;
  unsigned short int sy,tmp,tmp1;
  short int i;
  int j,k;

  tab = new TAB;
  memset(tab,0,sizeof(TAB));

  for(i=0;i<8;i++){
    *((unsigned short int *)tab+i)=*(TABLE+i);
    }
  for(i=8;i<=8;i++){
    tmp=*(TABLE+i);
    *((unsigned short int *)tab+i)=(tmp&0xff00);
    }
  for(i=9;i<(8+cmaxcode/2+1);i++){
    tmp=*(TABLE+i-1);
    tmp1=*(TABLE+i);
    *((unsigned short int *)tab+i)=((tmp1&0xff00)|(tmp&0x00ff));
    }
  j=(cmaxcode+1)%2;
  for(i=8+(cmaxcode/2)+cmaxcode%2;
	i<(8+(cmaxcode/2)+cmaxcode%2+(2+1+cmaxt/16)*(cmaxs-cmaxp))
	 ;i+=2+1+cmaxt/16){
    *((unsigned short int *)tab+i+j+1+(cmaxcode+1)%2)=*(TABLE+i);
    j+=1;
    *((unsigned short int *)tab+i+1+j+1+(cmaxcode+1)%2)= (*(TABLE+i+1))>>8;
    j+=1;
    for(k=0;k<1+cmaxt/16;k++){
      *((unsigned short int *)tab+i+2+k+j+1+(cmaxcode+1)%2)=*(TABLE+i+2+k);
      }
    if(k%2 == 1){j+=1;}
    }

  for(i= 8+(cmaxcode/2)+cmaxcode%2+(2+1+cmaxt/16)*(cmaxs-cmaxp);
	i<(8+(cmaxcode/2)+cmaxcode%2+(2+1+cmaxt/16)*(cmaxs-cmaxp)
	 +cmaxeps*(cmaxt/16+1)+cmaxany*(cmaxt/16+1)+cmaxp+1
	 +(cmaxp-cmaxt+1)*2+cmaxnamep+1);i++){
    *((unsigned short int *)tab+i+j+1+(cmaxcode+1)%2)=*(TABLE+i);
    }
  for(i=(8+(cmaxcode/2)+cmaxcode%2+(2+1+cmaxt/16)*(cmaxs-cmaxp)
       	 +cmaxeps*(cmaxt/16+1)+cmaxany*(cmaxt/16+1)+cmaxp+1
	 +(cmaxp-cmaxt+1)*2+cmaxnamep+1);
	i<(8+(cmaxcode/2)+cmaxcode%2+(2+1+cmaxt/16)*(cmaxs-cmaxp)
	 +cmaxeps*(cmaxt/16+1)+cmaxany*(cmaxt/16+1)+cmaxp+1
	 +(cmaxp-cmaxt+1)*2+cmaxnamep+1
	 +(cmaxname/2+2));
	 i++){
    tmp=*(TABLE+i);
    *((unsigned short int *)tab+i+j+1+(cmaxcode+1)%2)=((tmp&0x00ff)<<8)|((tmp&0xff00)>>8);
    }

  pc=cstartpc; altroot=pc;
  line=1; col=1;
  correct=True; mustread=True; running=True;
 errdist=100;
  lacts=0;
stacktop=-1;

  while(running){
    opcode=tab->code[pc];
    if(mustread && opcode<=epsa){
      NextSym(); mustread=False; errdist++; altroot=pc;
      }
/*    if(printnodes){
      WriteCard(fcon,pc,5);
      }*/
    pc++;
    switch(opcode){
      case t:
	if(typ==tab->code[pc]){
	  if(typ==eofsy){
	    running=False;
	    }
	  else{
	    pc++; mustread=True;
	    }
	  }
	else{
//	  Error(pc,altroot);
	  }
	break;
      case ta:
	if(typ==tab->code[pc]){
	  pc=pc+3; mustread=True;
	  }
	else{
	  pc=256*tab->code[pc+1]+tab->code[pc+2];
	  }
	break;
      case nt:
      case nts:
	sy=tab->code[pc];
	if(Match(typ,(tab->ntsymbols[sy-cmaxp-1].first)) ||
		 tab->ntsymbols[sy-cmaxp-1].del){
	  if(opcode==nts){
	    pc++; Semant(tab->code[pc]);
	    }
	  Push(pc+1); pc=tab->ntsymbols[sy-cmaxp-1].startpc;
	  altroot=pc;
	  }
	else{
//	  Error(pc,altroot);
	  }
	break;
      case nta:
      case ntas:
	sy=tab->code[pc];
	if(Match(typ,tab->ntsymbols[sy-cmaxp-1].first)){
	  pc=pc+3;
	  if(opcode==ntas){
	    Semant(tab->code[pc]); pc++;
	    }
	  Push(pc); pc=tab->ntsymbols[sy-cmaxp-1].startpc;
	  altroot=pc;
	  }
	else{
	  pc=tab->code[pc+1]*256+tab->code[pc+2];
	  }
	break;
      case any:
	mustread=True;
	break;
      case anya:
	if(Match(typ,tab->anyset[tab->code[pc]-1])){
	  pc=pc+3; mustread=True;
	  }
	else{
	  pc=tab->code[pc+1]*256+tab->code[pc+2];
	  }
	  break;
	case eps:
	  if(Match(typ,tab->epsset[tab->code[pc]-1])){
	    pc++;
	    }
	  else{
//	    Error(pc,altroot);
	    }
	  break;
	case epsa:
	  if(Match(typ,tab->epsset[tab->code[pc]-1])){
		pc=pc+3;
		}
	  else{
	    pc=tab->code[pc+1]*256+tab->code[pc+2];
	    }
	  break;
	case jmp:
		pc=tab->code[pc]*256+tab->code[pc+1];
		break;
	case ret:
		Pop(pc); altroot=pc;
		break;
	default:
	  if(correct){
	    Semant(opcode);
	    }
	  break;
	}
      }
isobuf = curtoken.isofname;
    corr=correct;
    delete tab;
  }/* Parse() */